Imports System.IO
Imports System.Drawing
Imports System.Windows.Forms

Public Class Listview
    Implements IDisposable 'Inherit from IDisposable if you need Basic4ppc to free resources when the application is closed.

    Private WithEvents ListView1 As System.Windows.Forms.ListView 'The "real" object.
    Public Event SelectionChanged As EventHandler 'The event handler name must match the event name.
    Private eventClickObject() As Object 'One object[] for each event (one event here).
    Private selecteditem, selectnummer As Integer

    Private ContextMenuClick() As Object 'One object[] for each event (one event here).
    Private WithEvents ContextMenu1 As ContextMenu 'The "real" object.
    Public Shadows Event ContextClick As EventHandler 'The event handler name must match the event name.
    Private ContextMenuText As String

    Sub New(ByVal FormName As Control, ByVal Left As Int32, ByVal Top As Int32, ByVal Width As Int32, ByVal Height As Int32)
        ListView1 = New System.Windows.Forms.ListView
        With ListView1
            .View = View.Details
            .Left = Left
            .Top = Top
            .Width = Width
            .Height = Height
        End With

        FormName.Controls.Add(ListView1)

        'This is the object that will pass with the event.
        'It must be in that format exactly.
        eventClickObject = New Object() {Me, "SelectionChanged"}

        ContextMenu1 = New System.Windows.Forms.ContextMenu
        ContextMenuClick = New Object() {Me, "ContextClick"}

    End Sub

    Public Sub AddContextMenu(ByVal Menue As String)
        Dim menuItem1 As New MenuItem
        menuItem1.Text = Menue
        ContextMenu1.MenuItems.Add(menuItem1)
        AddHandler menuItem1.Click, AddressOf CMenuClick
    End Sub

    Private Sub CMenuClick(ByVal sender As Object, ByVal e As System.EventArgs)
        'Point to menu item clicked
        Dim objCurMenuItem As MenuItem = CType(sender, MenuItem)
        ContextMenuText = objCurMenuItem.Text
        RaiseEvent ContextClick(ContextMenuClick, Nothing)
    End Sub

    Public ReadOnly Property SelectedContextMenuText() As String
        Get
            Return ContextMenuText
        End Get
    End Property

    Private Sub ListView1_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs) Handles ListView1.MouseUp
        ' If the right mouse button was clicked and released,
        ' display the shortcut menu assigned to the ListView.
        If e.Button = MouseButtons.Right Then
            ContextMenu1.Show(ListView1, New Point(e.X, e.Y))
        End If
    End Sub

    Public Sub AddColumn(ByVal Text As String, Optional ByVal ColumnWidth As Int32 = -2, _
        Optional ByVal TextAlignment As Int32 = 0, Optional ByVal ClickSort As Boolean = False)
  
            If TextAlignment = 0 Then
                ListView1.Columns.Add(Text, ColumnWidth, HorizontalAlignment.Left)
            ElseIf TextAlignment = 1 Then
                ListView1.Columns.Add(Text, ColumnWidth, HorizontalAlignment.Right)
            ElseIf TextAlignment = 2 Then
                ListView1.Columns.Add(Text, ColumnWidth, HorizontalAlignment.Center)
            End If
    End Sub

    Public Sub AddRow(ByVal ParamArray Celle() As String)
        Dim n As Integer = 0

        If UBound(Celle) > 0 Then
            With ListView1.Items.Add(New ListViewItem(Celle(0)))
                For n = 1 To ListView1.Columns.Count - 1
                    If n <= UBound(Celle) Then
                        .SubItems.Add(Celle(n))
                    End If
                Next n
            End With
        End If
    End Sub

    Public Sub LoadCSV(ByVal Datei As String, ByVal Separator As Char, ByVal HeaderExist As Boolean, ByVal CreateColumns As Boolean)
        Dim objReader As New StreamReader(Datei)
        Dim sLine As String = ""
        Dim strArray() As String ' Das Array fr die einzelnen cellen
        Dim tmpArray() As String ' Ein Array fr zwischenspeicher
        Dim i, n As Int32
        Dim pos As Int32
        Dim hochkomma As Char = Chr(34)

        'Erste Zeile mit Header berspringen
        If HeaderExist = True Then
            sLine = objReader.ReadLine()

            'Columns erzeugen
            If CreateColumns = True Then
                tmpArray = sLine.Split(Separator) ' In ein String-Array konvertieren
                For i = 0 To UBound(tmpArray)
                    AddColumn(tmpArray(i), 50, 0)
                Next
            End If
        End If

        ListView1.BeginUpdate()
        Do
            sLine = objReader.ReadLine()
            If Not sLine Is Nothing Then
                tmpArray = sLine.Split(Separator) ' In ein String-Array konvertieren
                ReDim strArray(UBound(tmpArray))
                i = 0
                n = 0
                Do
                    pos = InStr(tmpArray(i), hochkomma, CompareMethod.Text)
                    If pos = 0 Then
                        strArray(n) = tmpArray(i)
                    Else
                        strArray(n) = Replace(tmpArray(i) & Separator & tmpArray(i + 1), hochkomma, "")
                        i += 1
                    End If

                    n += 1
                    i += 1

                Loop Until i > UBound(tmpArray)

                With ListView1.Items.Add(New ListViewItem(strArray(0)))
                    For n = 1 To ListView1.Columns.Count - 1
                        If n <= i Then
                            .SubItems.Add(strArray(n))
                        End If
                    Next n
                End With

            End If
        Loop Until sLine Is Nothing
        objReader.Close()
        ListView1.EndUpdate()
    End Sub

    Private Function ListviewHeader(ByVal Separator As Char) As String
        Dim zeile As String = ""
        Dim i As Integer
        Dim header As Char = ""  '"﻿" 'Chr(0239) & Chr(0187) & Chr(0191)

        For i = 0 To ListView1.Columns.Count - 1
            zeile = zeile & ListView1.Columns.Item(i).Text
            If i < ListView1.Columns.Count - 1 Then
                zeile = zeile & Separator
            End If
        Next
        ListviewHeader = header & zeile
    End Function

    '*********************************************************************
    Public ReadOnly Property ColCount() As Int32
        Get
            Return ListView1.Columns.Count
        End Get
    End Property

    Public Property Left() As Int32
        Get
            Return ListView1.Left
        End Get
        Set(ByVal Value As Int32)
            ListView1.Left = Value
        End Set
    End Property

    Public Property Top() As Int32
        Get
            Return ListView1.Top
        End Get
        Set(ByVal Value As Int32)
            ListView1.Top = Value
        End Set
    End Property

    Public Property Width() As Int32
        Get
            Return ListView1.Width
        End Get
        Set(ByVal Value As Int32)
            ListView1.Width = Value
        End Set
    End Property

    Public Property Height() As Int32
        Get
            Return ListView1.Height
        End Get
        Set(ByVal Value As Int32)
            ListView1.Height = Value
        End Set
    End Property

    Public Property Enabled() As Boolean
        Get
            Return ListView1.Enabled
        End Get
        Set(ByVal Value As Boolean)
            ListView1.Enabled = Value
        End Set
    End Property

    Public Property Visible() As Boolean
        Get
            Return ListView1.Visible
        End Get
        Set(ByVal Value As Boolean)
            ListView1.Visible = Value
        End Set
    End Property

    Public Property FullRowSelect() As Boolean
        Get
            Return ListView1.FullRowSelect
        End Get
        Set(ByVal Value As Boolean)
            ListView1.FullRowSelect = Value
        End Set
    End Property

    Public ReadOnly Property RowCount() As Int32
        Get
            Return ListView1.Items.Count
        End Get
    End Property

    Public Sub SelectRow(ByVal Row As Integer)
        Dim Index As Integer
        Index = Row
        If Index > ListView1.Items.Count - 1 Then
            Index = ListView1.Items.Count - 1
        End If
        ListView1.Items(Index).Selected = True
        ListView1.EnsureVisible(Index)
        selecteditem = Index
    End Sub

    Public Sub RemoveRow(ByVal Index As Integer)
        If Index >= 0 And Index < ListView1.Items.Count Then
            ListView1.Items.RemoveAt(Index)
            If Index > 0 Then
                selecteditem = Index - 1
            Else
                selecteditem = 0
            End If
        End If
    End Sub

    Public ReadOnly Property SelectedRow() As Integer
        Get
            Return selecteditem
        End Get
    End Property

    Public ReadOnly Property DLLVersion() As Double
        Get
            Return 1.05
        End Get
    End Property

    Public Sub Dispose() Implements System.IDisposable.Dispose
        If Not ListView1 Is Nothing Then
            ListView1.Dispose()
        End If
    End Sub


End Class
